Nirva Application Platform - Bug #27

Crash du serveur Http sous Linux
08/23/2011 06:13 PM - Lionel Martin
Description

Bonjour,

Ce probléme n'a été reproduit que sous Linux. Sous la derniére version 64bits de Nirva (version 4.6.000), il n'y a pas eu de
probléme.

Le probléme est lié a un service Java, qui a chague commande va chercher le nom de I'application lié a la session qui a initié la
commande, via une commande APPLICATION:GET_NAME.

Le fonctionnement de I'application est le suivant :

- le session_open appelle une commande du service * le NV_INIT_SESSION du service est exécuté * la commande voulue
du service est exécutée

- lorsque la session est fermée, le service regoie une commande NV_EXIT_SESSION pour cette session.

Lors du session_open, si une erreur apparait (via le service => ERROR=YES, ou via la proc session_open => ERROR=ZUT), le
session_open retourne une erreur et la session est immédiatement close. Or le APPLICATION:GET_NAME exécuté dans le service
lors du NV_EXIT_SESSION lance alors une erreur qui n'est pas rattrapée et plante le serveur HTTP.

Sous Windows, tout s'exécute normalement.

Reproduction du probléme :

- installer le service joint

- installer I'application jointe

- voici les différentes commandes, avec les résultats obtenus en local :
http://localhost:1081/nv_app_BUG/NVS?Command&NV_CMD=MISC:NOP&ERROR=YES : Erreur lancée par le service, plante le
serveur HTTP * http://localhost:1081/nv_app_BUG/NVS?Command&NV_CMD=MISC:NOP&ERROR=ZUT : erreur lancée par la
procédure session_open, plante le serveur HTTP *

http://localhost:1081/nv_app_ BUG/NVS?Command&NV_CLOSE_SESSION=YES&NV_CMD=MISC:NOP&ERROR=NO : pas
d'erreur, pas de plantage

Le NV_CLOSE_SESSION n'est pas mis sur les URL obtenant une erreur, il n'y en a pas besoin. Sur la derniére, cela permet de
cleaner la session en méme temps.

*

Les sources du service sont incluses dans le package : répertoire Source du service.

Merci.
Cordialement.

Lionel Martin

History

#1 - 08/23/2011 06:15 PM - Pierre Marc

This is confirmed to be a bug. This will be corrected in version 4.6.000. We were trying to access a NULL application pointer.

#2 - 10/14/2011 11:10 AM - Pierre Marc

- Target version set to 4.6.000

#3 - 10/14/2011 11:11 AM - Pierre Marc
http://localhost:1081/nv_app_BUG/NVS?Command&NV_CMD=MISC:NOP&ERROR=YES
http://localhost:1081/nv_app_BUG/NVS?Command&NV_CMD=MISC:NOP&ERROR=ZUT
http://localhost:1081/nv_app_BUG/NVS?Command&NV_CLOSE_SESSION=YES&NV_CMD=MISC:NOP&ERROR=NO

- % Done changed from 0 to 100
